InsuranceClaim/Controllers/RenewController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using InsuranceClaim.Models;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.Owin;
using Insurance.Domain;
using AutoMapper;
using System.Configuration;
using System.Globalization;
using Insurance.Service;
using PayPal.Api;
using System.Web.Script.Serialization;
using System.Web.Configuration;
using System.Net;
using System.Text;
using System.IO;
using QRCoder;
using System.Drawing;
using System.Drawing.Imaging;
using Webdev.Payments;

namespace InsuranceClaim.Controllers
{
    [HandleError]
    public class RenewController : Controller
    {
        private ApplicationUserManager _userManager;
        Insurance.Service.smsService objsmsService = new Insurance.Service.smsService();

        string AdminEmail = WebConfigurationManager.AppSettings["AdminEmail"];
        string ZimnatEmail = WebConfigurationManager.AppSettings["ZimnatEmail"];
        string _pdfPath = "";
        string _pdfCode = "";

        decimal _InflationFactorAmt = 25;

        int _currencId = 6; //RTGS$
        public RenewController()
        {
            // UserManager = userManager;
        }

        public ApplicationUserManager UserManager
        {
            get
            {
                return _userManager ?? HttpContext.GetOwinContext().GetUserManager<ApplicationUserManager>();
            }
            private set
            {
                _userManager = value;
            }
        }

        //public ActionResult Index(int? vehicleid)
        //{
        //    Session["RenewVehicleId"] = vehicleid;
        //    CustomerModel custdata = new CustomerModel();
        //    bool userLoggedin = (System.Web.HttpContext.Current.User != null) && System.Web.HttpContext.Current.User.Identity.IsAuthenticated;
        //    string path = Server.MapPath("~/Content/Countries.txt");
        //    var countries = System.IO.File.ReadAllText(path);
        //    var resultt = Newtonsoft.Json.JsonConvert.DeserializeObject<RootObject>(countries);
        //    ViewBag.Cities = InsuranceContext.Cities.All();
        //    ViewBag.Countries = resultt.countries.OrderBy(x => x.code.Replace("+", ""));



        //    var vehicledetails = InsuranceContext.VehicleDetails.Single(where: $"Id = '{vehicleid}'");
        //    var customerdetail = InsuranceContext.Customers.Single(where: $"Id= '{vehicledetails.CustomerId}'");
        //    if (customerdetail != null)
        //    {

        //        custdata = Mapper.Map<Customer, CustomerModel>(customerdetail);
        //        var dbUser = UserManager.Users.FirstOrDefault(c => c.Id == customerdetail.UserID);
        //        if (dbUser != null)
        //        {
        //            custdata.EmailAddress = dbUser.Email;
        //        }

        //    }

        //    return View(custdata);
        //}

        [Authorize(Roles = "Renewals,Administrator,Team Leaders,Agent")]
        public ActionResult Index(int? vehicleid)
        {

            Session["RenewVehicleId"] = vehicleid;
            CustomerModel custdata = new CustomerModel();
            var GetUpdatedCustData = (CustomerModel)Session["ReCustomerDataModal"];
            bool userLoggedin = (System.Web.HttpContext.Current.User != null) && System.Web.HttpContext.Current.User.Identity.IsAuthenticated;
            string path = Server.MapPath("~/Content/Countries.txt");
            var countries = System.IO.File.ReadAllText(path);
            var resultt = Newtonsoft.Json.JsonConvert.DeserializeObject<RootObject>(countries);
            ViewBag.Cities = InsuranceContext.Cities.All();
            ViewBag.Countries = resultt.countries.OrderBy(x => x.code.Replace("+", ""));


            if (GetUpdatedCustData == null)
            {
                var vehicledetails = InsuranceContext.VehicleDetails.Single(where: $"Id = '{vehicleid}'");
                var customerdetail = InsuranceContext.Customers.Single(where: $"Id= '{vehicledetails.CustomerId}'");

                if (customerdetail != null)
                {
                    custdata = Mapper.Map<Customer, CustomerModel>(customerdetail);

                    // for approving 
                    //Session["ReCustomerDataModal"] = custdata;
                    //RenewApproveVRNToIceCash(customerdetail, vehicledetails);

                    var dbUser = UserManager.Users.FirstOrDefault(c => c.Id == customerdetail.UserID);
                    if (dbUser != null)
                    {
                        custdata.EmailAddress = dbUser.Email;
                    }

                }
            }
            else
            {
                if (GetUpdatedCustData != null)
                {
                    var User = UserManager.FindById(GetUpdatedCustData.UserID);
                    custdata.AddressLine1 = GetUpdatedCustData.AddressLine1;
                    custdata.AddressLine2 = GetUpdatedCustData.AddressLine2;
                    custdata.City = GetUpdatedCustData.City;
                    custdata.Id = GetUpdatedCustData.Id;
                    custdata.Country = GetUpdatedCustData.Country;
                    custdata.Zipcode = GetUpdatedCustData.Zipcode;
                    custdata.Gender = GetUpdatedCustData.Gender;
                    custdata.PhoneNumber = GetUpdatedCustData.PhoneNumber;
                    custdata.NationalIdentificationNumber = GetUpdatedCustData.NationalIdentificationNumber;
                    custdata.DateOfBirth = GetUpdatedCustData.DateOfBirth;
                    custdata.EmailAddress = GetUpdatedCustData.EmailAddress;
                    custdata.FirstName = GetUpdatedCustData.FirstName;
                    custdata.LastName = GetUpdatedCustData.LastName;
                    custdata.CountryCode = GetUpdatedCustData.CountryCode;
                    custdata.IsCustomEmail = GetUpdatedCustData.IsCustomEmail;
                }
            }

            return View(custdata);
        }



        public void UpdateDeactiveVehilce(int? vehicleid)
        {
            if (vehicleid != 0)
            {
                var vehicleDetails = InsuranceContext.VehicleDetails.Single(where: "Id=" + vehicleid + "and IsActive=1");
                if (vehicleDetails != null)
                {
                    vehicleDetails.IsActive = false;
                    vehicleDetails.isLapsed = true;
                    InsuranceContext.VehicleDetails.Update(vehicleDetails);

                    var splitRenewPolicyNumber = vehicleDetails.RenewPolicyNumber.Replace("-2", "-3");

                    var renewVehicleDetails = InsuranceContext.VehicleDetails.Single(where: "RenewPolicyNumber='" + splitRenewPolicyNumber + "'");

                    if (renewVehicleDetails != null)
                    {
                        var summaryVehicleDetails = InsuranceContext.SummaryVehicleDetails.Single(where: "VehicleDetailsId=" + renewVehicleDetails.Id);

                        if (summaryVehicleDetails != null)
                        {
                            var summaryDetails = InsuranceContext.SummaryDetails.Single(summaryVehicleDetails.SummaryDetailId);


                            if (summaryDetails != null)
                            {

                                decimal radioLicenseCost = 0;
                                if (renewVehicleDetails.IncludeRadioLicenseCost == true)
                                {
                                    radioLicenseCost = renewVehicleDetails.RadioLicenseCost.Value;
                                }

                                summaryDetails.TotalPremium = renewVehicleDetails.Premium + renewVehicleDetails.StampDuty + renewVehicleDetails.ZTSCLevy + renewVehicleDetails.VehicleLicenceFee + radioLicenseCost;
                                summaryDetails.TotalStampDuty = renewVehicleDetails.StampDuty;
                                summaryDetails.TotalZTSCLevies = renewVehicleDetails.ZTSCLevy;
                                summaryDetails.TotalRadioLicenseCost = renewVehicleDetails.RadioLicenseCost;

                                InsuranceContext.SummaryDetails.Update(summaryDetails);

                            }
                        }
                    }
                }
            }
        }

        public ActionResult BackToCustomerDetail(int id = 0)
        {
            var vehicleId = (Int32)Session["RenewVehicleId"];

            if (id != -1) // -1 use for getting session value when click on back button
            {
                //  RemoveSession();
                ClearRenewSession();
            }

            bool userLoggedin = (System.Web.HttpContext.Current.User != null) && System.Web.HttpContext.Current.User.Identity.IsAuthenticated;
            string path = Server.MapPath("~/Content/Countries.txt");
            var countries = System.IO.File.ReadAllText(path);
            var resultt = Newtonsoft.Json.JsonConvert.DeserializeObject<RootObject>(countries);
            ViewBag.Countries = resultt.countries.OrderBy(x => x.code.Replace("+", ""));

            //string paths = Server.MapPath("~/Content/Cities.txt");
            //var cities = System.IO.File.ReadAllText(paths);
            //var resultts = Newtonsoft.Json.JsonConvert.DeserializeObject<RootObjects>(cities);
            //ViewBag.Cities = resultts.cities;

            ViewBag.Cities = InsuranceContext.Cities.All();



            if (id > 0) // if staff try to edit Qutation
            {
                SetCustomerValueIntoSession(id); // here id represent to summardetialid during edit the Qutation
            }


            if (userLoggedin && id == 0)
            {
                var customerModel = new CustomerModel();
                var _User = UserManager.FindById(User.Identity.GetUserId().ToString());

InsuranceClaim/Views/Endorsement/EndorsementDetail.cshtml
@using Insurance.Service;
@model InsuranceClaim.Models.ListEndorsementPolicy
@{
    ViewBag.Title = "EndorsementDetail";
    Layout = "~/Views/Shared/_InsuranceMain.cshtml";
}
<div class="productsave-section">
    <div class="container-fluid">
        <div class="row">
            <div class="col-xs-12 col-sm-8 col-md-8 col-lg-8 products-top">
                <div class="head-title">
                    <h2>Endorsement Detail</h2>
                </div>
            </div>
            @*<div class="col-xs-12 col-sm-4 col-md-4 col-lg-4 add-btn">
                <div class="text-right">
                    <form>
                        <input class="btn btn-primary" type="button" value="Add" onclick="window.location.href='@Url.Action(" Index", "CustomerRegistration" )'" />
                    </form>
                </div>
                </div*@
        </div>
       
        <div class="row">
            <div class="col-sm-4 col-md-4">
                <div class="text-left">
                    @Html.TextBox("searchText", null, new { @class = "form-control", @placeholder = "Endorsement Search" })
                </div>
            </div>

            <div class="col-sm-3 col-md-3">

            </div>

        </div>

        @*@using (Html.BeginForm("SearchMyPolicy", "Account", FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
                {
                <div class="row">
                    <div class="col-md-12 next-btn">
                        <div class="row">
                            <div class="col-sm-4 col-md-4">
                                <div class="text-left">
                                    @Html.TextBox("searchText", null, new { @class = "form-control", @placeholder = "Policy Number / Customer Name" })
                                </div>
                            </div>

                            <div class="col-sm-3 col-md-3">

                            </div>
                        </div>
                    </div>
                </div>
            }*@



        <br />
        <br />
        <div class="policy-table-grid-main">
            <table class="table table-striped">

                <tbody>

                    @if (Model != null)
                    {
                        if (Model.listendorsementpolicy.Count == 0)
                        {
                            <label>No Policies Found</label>
                        }
                    }

                    <tr class="policyheading-tr">
                        <th>Endorsement No</th>
                        <th>Policy Number</th>
                        <th>Customer Name</th>
                        <th>Customer Email</th>
                        <th>Payment Method</th>
                        <th>Currency</th>
                        <th>Total Sum Insured</th>
                        <th>Total Premium</th>
                        <th>Created On</th>
                        <th class="thwidth100">Action(s)</th>

                    </tr>
                    @{ int rowNo = 0; }
                    @foreach (var item in Model.listendorsementpolicy.ToList())
                    {
                        <tr class="policynumber-tr">
                            <td>@item.PolicyNumber-@(rowNo += 1)</td>
                            <td>@item.PolicyNumber</td>
                            <td>@item.CustomerName</td>
                            <td>@item.CustomerEmail
                            <td>@MiscellaneousService.GetPaymentMethodNamebyID(item.PaymentMethodId)</td>
                            <td>@item.Currency</td>
                            <td>@item.TotalSumInsured</td>
                            <td>@item.TotalPremium</td>
                            
                            <td>@item.createdOn.ToString("dd-MMM-yyyy")</td>
                            <td>
                                <div class="tbl-btn-list">
                                    <ul class="list-inline">
                                        @*
                                            <li>@Html.ActionLink("View Policy", "RiskDetail", "Account", new { id = item.SummaryId }, new { @class = "btn-sm btn-primary" })</li>*@

                                        <li>@Html.ActionLink("View Endorsement Policy", "ViewEndorsementCustomer", "Endorsement", new { id = item.EndorsementSummaryId }, new { @class = "btn-sm btn-primary" })</li>


                                        @*@foreach (var _item in item.Vehicles)
                                            {
                                                if (DateTime.Now >= _item.RenewalDate && DateTime.Now >= _item.RenewalDate.AddDays(-21))
                                                {
                                                    <li>@Html.ActionLink("Renew Policy", "RiskDetail", "Account", new { id = item.PolicyNumber }, new { @class = "btn-sm btn-primary" })</li>

                                                    break;
                                                }
                                            }

                                            @if (User.IsInRole("Staff") || User.IsInRole("Administrator"))
                                            {
                                                <li><a href="javascript:void(0)" class="btn-sm btn-primary" onclick="RsendPolicy(@item.SummaryId)">Resend Policy </a> </li>
                                            }


                                            @if (User.IsInRole("Administrator"))
                                            {
                                                <li>@Html.ActionLink("Endorsement", "EndorsementDetials", "Account", new { sumaryid = item.SummaryId }, new { @class = "btn-sm btn-primary" })</li>

                                            }*@

                                    </ul>
                                </div>
                            </td>
                        </tr>
                        @*
                            <tr>
                                <td colspan="7">
                                    <table class="policy-table-grid policyList" style="width:100%">
                                        <tr>
                                            <th>Vehicle</th>
                                            <th>Sum Insured</th>
                                            <th>Auto-Fac Sum Insured</th>
                                            <th>AutoFac Premium</th>
                                            <th>Fac Sum Insured</th>
                                            <th>Fac Premium</th>
                                            <th>Reinsurance Broker Commission</th>
                                            <th>Facultative Commission</th>
                                            <th>Status</th>
                                            <th>Actions(s)</th>
                                        </tr>
                                        @foreach (var _item in item.Vehicles)
                                        {
                                        <tr>
                                            <td>@MiscellaneousService.GetMakeNamebyMakeCode(_item.MakeId)/@MiscellaneousService.GetModelNamebyModelCode(_item.ModelId)</td>
                                            <td>$@_item.SumInsured</td>
                                            <td>$@_item.AutoFacReinsuranceAmount</td>
                                            <td>$@_item.AutoFacPremium</td>
                                            <td>$@_item.FacReinsuranceAmount</td>
                                            <td>$@_item.FacPremium</td>
                                            <td>$@_item.BrokerCommission</td>
                                            <td>$@_item.FacultativeCommission</td>


                                            @if (_item.isLapsed)
                                            {
                                            <td>Lapsed</td>
                                            <td></td>
                                            }
                                            else if (!_item.isActive)
                                            {
                                            <td>Disabled</td>
                                            <td><button type="button" class="btn-sm btn-primary" onclick="javascript:confirm('In Progress !!');">Pay To Activate</button></td>
                                            }
                                            else if (DateTime.Now < _item.RenewalDate.AddDays(-21))
                                            {
                                            <td>In Force</td>

                                            if (_item.BalanceAmount > 0.00m)
                                            {
                                            <td><button type="button" class="btn-sm btn-danger" onclick="javascript: alert('Your Balance Amount is : $ @_item.BalanceAmount');">Pay Balance Amount</button><br /><br /><button type="button" class="btn-sm btn-primary" onclick="showPopuppDocument('@item.PolicyNumber','@item.CustomerId','@_item.VehicleId')">View/Upload Document</button></td>
                                            }
                                            else
                                            {
                                            <td><button type="button" class="btn-sm btn-primary" onclick="showPopuppDocument('@item.PolicyNumber','@item.CustomerId','@_item.VehicleId')">View/Upload Document</button></td>
                                            }

                                            }
                                            else if (DateTime.Now >= _item.RenewalDate.AddDays(-21) && DateTime.Now <= _item.RenewalDate)
                                            {
                                            <td>Renew</td>
                                            <td>@Html.ActionLink("Pay Premium", "RiskDetail", "Renew", new { id = _item.VehicleId }, new { @class = "btn-sm btn-danger", @style = "    width: 100%;    float: left;    text-align: center;" })<br /><br /><button type="button" class="btn-sm btn-primary" onclick="showPopuppDocument('@item.PolicyNumber','@item.CustomerId','@_item.VehicleId')">View/Upload Document</button></td>

                                            }
                                            else if (DateTime.Now > _item.RenewalDate && _item.isLapsed != true)
                                            {
                                            <td>Lapsed</td>
                                            <td>@Html.ActionLink("Renew", "RiskDetail", "Renew", new { id = _item.VehicleId }, new { @class = "btn-sm btn-danger", @style = "    width: 100%;    float: left;    text-align: center;" })</td>
                                            }

                                        </tr>

                                    </table>
                                </td>
                            </tr>*@
                    }
                </tbody>

            </table>
        </div>
    </div>

</div>
<script>

    $(document).ready(function () {
        $("#searchText").on("keyup", function () {
            var value = $(this).val().toLowerCase();
            $(".table>tbody tr").filter(function () {
                $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
            });
        });
    });


</script>

InsuranceClaim/Views/Endorsement/EndorsementPaymentDetail.cshtml
@model InsuranceClaim.Models.CardDetailModel
@{
    ViewBag.Title = "EndorsementPaymentDetail";
    Layout = "~/Views/Shared/_InsuranceMain.cshtml";

}

@*<h2>EndorsementPaymentDetail</h2>*@




<div class="top-banner-section">
    <div class="container">
        <div class="car-insurance-content">
            <h2>Get Car Insurance In Less<br>Than 5 Minutes<h2>
        </div>
    </div>
</div>


<div class="body-content-section">
    <div class="Process-step-section">
        <div class="container">
            <div class="row bs-wizard">
                <div class="process-block">
                    <div class="col-xs-2 bs-wizard-step complete">
                        <div class="progress"><div class="progress-bar"></div></div>
                        <a href="#" class="bs-wizard-dot"></a>
                        <div class="text-center bs-wizard-stepnum">Client Details</div>
                    </div>

                    @*<div class="col-xs-2 bs-wizard-step complete">
                             complete
                            <div class="progress"><div class="progress-bar"></div></div>
                            <a href="#" class="bs-wizard-dot"></a>
                            <div class="text-center bs-wizard-stepnum">Product Details</div>
                        </div>*@

                    <div class="col-xs-2 bs-wizard-step complete">
                        <!-- complete -->
                        <div class="progress"><div class="progress-bar"></div></div>
                        <a href="#" class="bs-wizard-dot"></a>
                        <div class="text-center bs-wizard-stepnum">Risk Details</div>
                    </div>

                    <div class="col-xs-2 bs-wizard-step complete">
                        <!-- active -->
                        <div class="progress"><div class="progress-bar"></div></div>
                        <a href="#" class="bs-wizard-dot"></a>
                        <div class="text-center bs-wizard-stepnum">Summary Details</div>
                    </div>

                    <div class="col-xs-2 bs-wizard-step active">
                        <!-- active -->

                        <div class="progress"><div class="progress-bar"></div></div>
                        <a href="#" class="bs-wizard-dot"></a>
                        <div class="text-center bs-wizard-stepnum">Payment Details</div>
                    </div>

                </div>
            </div>
        </div>
    </div>

    <div class="form-section-top">
        <div class="container">
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 form-section-col">
                    <div class="form-group-section">
                        <div class="form-title">
                            <h4>Endorsement Payment Detail</h4>
                        </div>

                        @if (TempData["ErrorMsg"] != null)
                        {
                            <div class="alert alert-danger">
                                @TempData["ErrorMsg"]
                            </div>
                        }
                        <div class="form-group-input">
                            @using (Html.BeginForm("PaymentWithCreditCard", "Endorsement"))
                            {<div>
                                @*@Html.HiddenFor(m => m.SummaryDetailId)*@
                                 @Html.HiddenFor(m => m.EndorsementSummaryId)
                            </div>

                            <div class="row">
                                <div class="col-md-12 form-group-text">
                                    <div class="form-group">
                                        <div class="controls">
                                            @Html.Label("Card Number", new { @class = "gender-label" })
                                            @Html.TextBoxFor(m => m.CardNumber, new { @class = "form-control numeric", @autocomplete = "off", @placeholder = "Card Number", @maxlength = "16" })
                                            @Html.ValidationMessageFor(m => m.CardNumber, "", new { @class = "text-danger" })
                                            <span id="credit-card-type-text" style="color:red" class="help-inline"></span>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label>Name On Card</label>
                                        <div class="controls">
                                            <div class="pull-left" id="accepted-cards-images">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                                <div class="row">
                                    <div class="col-md-12 form-group-text">
                                        <div class="form-group">
                                            @Html.TextBoxFor(m => m.NameOnCard, new { @class = "form-control", @autocomplete = "off", @placeholder = "Name on Card" })
                                            @Html.ValidationMessageFor(m => m.NameOnCard, "", new { @class = "text-danger" })
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.Label("Expiry Date", new { @class = "gender-label" })
                                            <div class='input-group date' id='datetimepicker1'>
                                                @Html.TextBoxFor(m => m.ExpiryDate, new { @class = "form-control", @autocomplete = "off", @placeholder = "MM/YYYY" })

                                                <span class="input-group-addon">
                                                    <span class="glyphicon glyphicon-calendar"></span>
                                                </span>
                                            </div>
                                            <div>@Html.ValidationMessageFor(m => m.ExpiryDate, "", new { @class = "text-danger" })</div>
                                        </div>
                                    </div>
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.Label("CVC", new { @class = "gender-label " })
                                            @Html.TextBoxFor(m => m.CVC, new { @class = "form-control numeric", @autocomplete = "off", @placeholder = "Cvc Number", @maxlength = "3" })
                                            <div>
                                                @Html.ValidationMessageFor(m => m.CVC, "", new { @class = "text-danger" })
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-md-12 next-btn">
                                        <div class="row">
                                            <div class="col-sm-6 col-md-6">
                                                <div class="text-left">
                                                    <div class="back-left"><button type="button" onclick="gotoPeriviouse()" class="btn">Back</button></div>
                                                    <a style="display:none" id="previouselink" href="/Endorsement/EndorsementSummaryDetail" class="back"></a>
                                                </div>
                                            </div>
                                            <div class="col-sm-6 col-md-6">
                                                <div class="text-right">
                                                    <button type="submit" class="btn">Next</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                            }

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</div>



<script src="~/Scripts/jquery.creditCardValidator.js"></script>
<script type="text/javascript">


    function gotoPeriviouse() {
        $("#previouselink")[0].click();

    }
    $(function () { // will trigger when the document is ready
        $('#datetimepicker1').datetimepicker({
            format: 'MM/YYYY'
           // minDate: new Date()
        });
        $('#CardNumber').validateCreditCard(function (result) {

            $('#credit-card-type-text').html((result.card_type == null ? '' : result.card_type.name));


        });
    });

</script>